<template>
  <b-card
    no-body
    class="coscine_card m-2 text-center"
    :class="isLoading || disabled ? 'bg-secondary-subtle' : ''"
    @click.prevent="openCard()"
  >
    <!-- Stretched Link (Card) -->
    <a
      v-if="!isLoading && !disabled"
      :href="hrefFromRouter(to)"
      class="stretched-link"
    />

    <!-- Badge -->
    <template #header>
      <b-badge
        v-if="badgeVisibility"
        pill
        :variant="disabled ? 'secondary' : badgeType"
      >
        {{ badgeText }}
      </b-badge>
    </template>

    <!-- Settings Button -->
    <b-button
      v-if="!disabled && toSettings"
      size="sm"
      variant="outline-primary"
      class="settings_button"
      @click.stop.prevent="openSettings"
    >
      <i-bi-pencil-fill />
      <!-- Stretched Link (Settings) -->
      <a
        v-if="!isLoading && !disabled"
        :href="hrefFromRouter(toSettings)"
        class="stretched-link"
      />
    </b-button>

    <b-card-body class="pt-0 pb-0 px-">
      <div class="mb-1">
        <!-- Loading Spinner -->
        <b-spinner
          v-if="isLoading"
          variant="primary"
          class="card_icon text-primary"
        />
        <!-- Icon -->
        <template v-else>
          <i-bi-plus-circle-fill
            v-if="cardIcon === createIcon"
            width="2.4rem"
            height="2.4rem"
            :class="disabled ? 'text-secondary' : 'text-primary'"
          />
          <FluentArchive32Regular
            v-else-if="cardIcon === resourceIcon"
            class="card_icon"
            :class="disabled ? 'text-secondary' : 'text-primary'"
          />
          <i-bi-folder2-open
            v-else-if="cardIcon === projectIcon"
            class="card_icon"
            :class="disabled ? 'text-secondary' : 'text-primary'"
          />
          <FluentArchiveSettings32Regular
            v-else-if="cardIcon === resourceIconDisabled"
            class="card_icon"
            :class="disabled ? 'text-secondary' : 'text-primary'"
          />
          <i-bi-circle-fill
            v-else
            class="card_icon"
            :class="disabled ? 'text-secondary' : 'text-primary'"
          />
        </template>
      </div>
      <!-- Title -->
      <b-card-text>
        <span class="card_title h6">{{ title }}</span>
      </b-card-text>
    </b-card-body>
  </b-card>
</template>

<script lang="ts">
import type { BaseColorVariant } from "bootstrap-vue-next";
import type { TranslateResult } from "vue-i18n";
import type { RouteLocationRaw } from "vue-router";

// For more icons see https://icon-sets.iconify.design/?search-page=1
// Importing using unplugin-icons
import FluentArchive32Regular from "~icons/fluent/archive-32-regular";
import FluentArchiveSettings32Regular from "~icons/fluent/archive-settings-32-regular";

export default defineComponent({
  components: {
    FluentArchive32Regular,
    FluentArchiveSettings32Regular,
    // Register other icons as needed
  },
  props: {
    title: {
      type: [String, Object] as PropType<
        string | TranslateResult | null | undefined
      >,
      required: true,
    },
    badgeText: {
      default: "",
      type: [String, Object] as PropType<string | TranslateResult>,
    },
    badgeVisibility: {
      default: false,
      type: Boolean,
    },
    badgeType: {
      default: "warning",
      type: String as PropType<keyof BaseColorVariant>,
    },
    type: {
      default: "",
      type: String,
      required: false,
    },
    toSettings: {
      default: null,
      type: Object as PropType<RouteLocationRaw | null>,
    },
    to: {
      type: Object as PropType<RouteLocationRaw>,
      required: true,
    },
    isLoading: {
      default: false,
      type: Boolean,
    },
    disabled: {
      default: false,
      type: Boolean,
    },
  },

  data() {
    return {
      createIcon: "plus-circle-fill",
      resourceIcon: "archive",
      resourceIconDisabled: "archive-off",
      projectIcon: "folder2-open",
      placeHolderIcon: "circle-fill",
    };
  },

  computed: {
    cardIcon(): string {
      if (this.type === "create") {
        return this.createIcon;
      } else if (this.type === "project") {
        return this.projectIcon;
      } else if (this.type === "resource") {
        if (this.disabled) {
          return this.resourceIconDisabled;
        } else {
          return this.resourceIcon;
        }
      } else {
        return this.placeHolderIcon;
      }
    },
  },

  methods: {
    hrefFromRouter(to: RouteLocationRaw) {
      const routeData = this.$router.resolve(to);
      return routeData.href;
    },
    openCard() {
      if (!this.disabled) {
        this.$emit("open-card", this.to);
      }
    },
    openSettings() {
      if (!this.disabled) {
        this.$emit("open-card-settings", this.toSettings);
      }
    },
  },
});
</script>

<style scoped>
.coscine_card {
  /* Header + Icon + Text = (Card) */
  min-width: 9rem;
  min-height: 9rem;
  max-width: 9rem;
  max-height: 9rem;
}
.coscine_card:hover {
  background-color: var(--bs-secondary-bg-subtle) !important;
}
.coscine_card:hover .settings_button {
  visibility: visible;
}
.coscine_card :deep(.card-header) {
  /* Header + (Icon) + Text = Card */
  /* (Padding) + Settings Icon = Header */
  height: 2.2rem;
  padding: 0.25rem;
  background-color: transparent;
  border: 0;
  text-align: center;
}
.coscine_card :deep(.settings_button svg) {
  width: 1.2em;
  height: 1.2em;
}
.coscine_card :deep(.settings_button) {
  /* Pin button in the top-right corner */
  position: absolute;
  right: 0;
  margin: 0.25rem;
  /* */
  visibility: hidden;
  /* Padding + (Settings Icon) = Header */
  width: 1.7rem;
  height: 1.7rem;
  padding: 0;
}
.card_icon {
  /* Header + (Icon) + Text = Card */
  width: 2.9rem;
  height: 2.9rem;
}
.card_title {
  display: -webkit-box;
  /* Header + Icon + (Text) = Card */
  height: 3.6rem;
  line-height: 1.15rem;
  display: -webkit-box;
  -webkit-line-clamp: 3;
  -webkit-box-orient: vertical;
  overflow: hidden;
  /* Remove h6 bottom margin */
  margin-bottom: 0;
}
</style>
